<?php 
/*
Template Name: Sitemap Page
*/
?>
<?php the_post(); ?>

<?php 
$et_ptemplate_settings = array();
$et_ptemplate_settings = maybe_unserialize( get_post_meta($post->ID,'et_ptemplate_settings',true) );

$fullwidth = isset( $et_ptemplate_settings['et_fullwidthpage'] ) ? (bool) $et_ptemplate_settings['et_fullwidthpage'] : (bool) $et_ptemplate_settings['et_fullwidthpage'];
?>

<?php get_header(); ?>

<div id="container">
	<div id="left-div">
		<div id="left-inside">
			<!--Start Post-->
			<div class="post-wrapper<?php if ($fullwidth) echo(' no_sidebar'); ?>">
				<?php include(TEMPLATEPATH . '/includes/share.php'); ?>
				<h3 class="post-title"><a href="<?php the_permalink() ?>" rel="bookmark" title="<?php printf(__('Permanent Link to %s','GrungeMag'), get_the_title()) ?>">
					<?php the_title(); ?>
					</a></h3>
				<div style="clear: both;"></div>
				
				<?php $width = get_option('grungemag_thumbnail_width_pages');
					  $height = get_option('grungemag_thumbnail_height_pages');
					  $classtext = 'alignleft';
					  $titletext = get_the_title();
					
					  $thumbnail = get_thumbnail($width,$height,$classtext,$titletext,$titletext);
					  $thumb = $thumbnail["thumb"]; ?>
				
				<?php if($thumb <> '' && get_option('grungemag_page_thumbnails') == 'on') { ?>
					<?php print_thumbnail($thumb, $thumbnail["use_timthumb"], $titletext , $width, $height, $classtext); ?>
				<?php }; ?>
				
				<?php the_content(); ?>
				
				<?php wp_link_pages(array('before' => '<p><strong>'.__('Pages','GrungeMag').':</strong> ', 'after' => '</p>', 'next_or_number' => 'number')); ?>
				
				<div id="sitemap">
					<div class="sitemap-col">
						<h2><?php _e('Pages','GrungeMag'); ?></h2>
						<ul id="sitemap-pages"><?php wp_list_pages('title_li='); ?></ul>
					</div> <!-- end .sitemap-col -->
					
					<div class="sitemap-col">
						<h2><?php _e('Categories','GrungeMag'); ?></h2>
						<ul id="sitemap-categories"><?php wp_list_categories('title_li='); ?></ul>
					</div> <!-- end .sitemap-col -->
					
					<div class="sitemap-col<?php echo ' last'; ?>">
						<h2><?php _e('Tags','GrungeMag'); ?></h2>
						<ul id="sitemap-tags">
							<?php $tags = get_tags();
							if ($tags) {
								foreach ($tags as $tag) {
									echo '<li><a href="' . get_tag_link( $tag->term_id ) . '">' . $tag->name . '</a></li> ';
								}
							} ?>
						</ul>
					</div> <!-- end .sitemap-col -->
										
					<div class="sitemap-col">
						<h2><?php _e('Authors','GrungeMag'); ?></h2>
						<ul id="sitemap-authors" ><?php wp_list_authors('show_fullname=1&optioncount=1&exclude_admin=0'); ?></ul>
					</div> <!-- end .sitemap-col -->
				</div> <!-- end #sitemap -->
				
				<div class="clear"></div>
				
				<?php edit_post_link(__('Edit this page','GrungeMag')); ?>
				
				<div style="clear: both;"></div>
			</div>
			
		</div>
	</div>
<!--Begin Sidebar-->
<?php if (!$fullwidth) get_sidebar(); ?>
<!--End Sidebar-->
<!--Begin Footer-->
<?php get_footer(); ?>
<!--End Footer-->
</body>
</html>
